#define EQU .equ
#define END .end
#define DB   .DB
#define DW   .DW
#define ORG .org

; --------------------------------------------
; pstart urcuje zaciatok programu

pstart  EQU 0005h		; pre beh z EPROM
;pstart  EQU 4000h		; pre beh z RAM		


; zahlavie prveho bloku dat
; Toto sluzi na vytvorenie hlavicky pri prenose cez seriovy port
; Hlavicka ma 5 bajtov a je pred samotnym programom
; Pri napaleni do EPROM treba prvych 5 bajtov nahradit nulami (NOP)
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 	ORG 	fstart
	DB	01h			; priznak dat
	DW	pstart			; pociatocna adresa
	DW	length			; dlzka bloku dat
;	DB	00, 00, 00, 00, 00	; bez zahlavia
; ---------------------------------------------
; hlavny program


LS174	EQU 11110111b		; memory mapping, audio_out, timers	(PORT3)
LS374	EQU 11111101b		; printer port	      			(PORT9)
LS175	EQU 11111110b		; beeper and relay    			(PORT10)	
LS173	EQU 11111110b		; LED, strobe and serial_out		(PORT10)
LS373	EQU 0FFE0h		; keyboard, audio_in and serial_in      (IN-PORT)

; --------------------------------------------

	
	ORG pstart
start:	NOP	
	DI
; --------------------------------------------
; test grafiky
VIDEO:	LD	A, 10b		; pre RAM
;	LD	A, 0		; pre ROM
	LD	I, A		; mapovacia hodnota bude ulozena v I
	LD	L, A		; uschovaj
	LD 	A, 30h		; najskor control word
	OR	L
        OUT	(LS174),A	
	LD	B, 14h
	LD	C, 12h
	RRC	C
	IN	A, (C)
	LD	B, 7Ah
	LD	C, 7Ah
	RRC	C
	IN	A, (C)
	LD	BC, 0B2B4h
	RRC	C
	IN	A, (C)
	LD	A, L		; citac 0
	OUT	(LS174), A
	LD	BC, 40FFh
	RRC	C
	IN	A, (C)
	LD	A, 10h		; citac 1
	OR	L
	OUT	(LS174),A
	LD	BC, 2F10h
	RRC	C
	IN	A, (C)
	LD	BC, 0001h
	RRC	C
	IN	A, (C)
	LD	A, 20h		; citac 2
	OR	L
	OUT	(LS174), A
	LD	BC, 2938h
	RRC	C
	IN	A, (C)
	LD	BC, 0001h
	RRC	C
	IN	A, (C)
	LD	B, 4		; bude sa opakovat 4x
VID0:	EXX
	LD	HL, 0D800h	; zaciatok VideoRAM
	LD	DE, 0D801h	; posledny stlpec
	LD	BC, 0FFh
	LD	A, 0FFh		; uloz FF
	LD	(HL), A
	LDIR
	LD	HL, 0D900h	; predposledny stlpec
	LD	DE, 0D901h
	LD	BC, 0FFh
	XOR	A		; uloz 00
	LD	(HL), A
	LDIR
	LD	HL, 0D800h	; zaciatok VideoRAM
	LD	DE, 0DA00h 	; posun o dva stlpce
	LD	BC, 2600h	; velkost VideoRAM - 2 stlpce
	LDIR			; zreplikuj
	LD	A, I
	OR	1
	OUT	(LS174), A	; rozsviet
	LD	IY, VID1
	LD	HL, 4000	; trochu cakaj
	JP	WAIT
VID1:	LD	HL, 0FEFFh
	LD	DE, 0FFFFh	; 
	LD	BC, 2700h	
	LDDR			; posun obrazovku dolava
	LD	HL, 0D800h	; zaciatok VideoRAM
	LD	DE, 0D801h	; posledny stlpec
	LD	BC, 0FFh
	XOR	A		; bude tam 00
	LD	(HL), A
	LDIR
	LD	IY, VID2
	LD	HL, 4000	; a cakaj
	JP	WAIT
VID2:	EXX
	DJNZ	VID0		; zopakuj
; --------------------------------------------
; zhasnutie displeja
NOVID:	LD	A, I
	OUT	(LS174), A	; zhasni
	
; --------------------------------------------	
; test zvuku
	LD	IX, BEEP1	; navratova adresa do IX (stack nebude pouzity)	
	LD	C, 32		; zapipaj stupnicu
	JP	BEEP
BEEP1:	LD	IX, BEEP2
	LD	C, 64
	JP	BEEP
BEEP2:	LD	IX, LED
	LD	C, 128
	JP	BEEP
; --------------------------------------------	
; test LED a relatka
LED:	LD	B, 5		; blikat bude 5-krat
LEDON:	LD	A, 00001100b	
	OUT	(LS173), A	; zapni obidve LED a rele
	LD	HL, 6000h
	LD	IY, LEDOFF
	JP	WAIT
LEDOFF:	LD	A, 00011111b
	OUT	(LS173), A	; vypni LED, aj rele
	LD	HL, 6000h
	LD	IY, LEDEND
	JP	WAIT		; navrat na LEDON
LEDEND:	DJNZ	LEDON
; --------------------------------------------		
; dump ROM cez seriovu linku (16kB) 57 600Bd
BEEP3:	LD	IX, ROMDUMP 	; navratova adresa
	LD	C, 64
	JP	BEEP
ROMDUMP:LD	HL, 0		; zaciatok pamate
	LD	BC, 16384	; velkost ROM vratane zrkadla
	LD	IX, ROM1	; navratova adresa zo seriovej rutiny
ROM0:   LD	A, (HL)		; nacitaj z ROM
	EXX			; vymena registrov
	JP	T57k6		; odosli cez seriovy port
ROM1:	EXX
	INC	HL
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, ROM0	; nacitaj dalsi bajt
; --------------------------------------------	
; test jedneho bajtu v RAM
; po nacitani zistuje, ci su vsetky bity OK, pri zlom zmeni ton
RAMTEST:LD	HL, 55AAh	; lubovolne miesto v RAM
	LD	(HL), 0FFh
	LD	E, (HL)
	LD	B, 8		; bude testovat postupne vsetkych 8 bitov
	LD	IX, RAM2
RAM1:	LD	A, E
	RRCA			; odrotuje do Carry
	LD	E, A
	JR	C, MEM1		; zhoduje sa bit
	LD	C, 128		; nie, vysoky ton
	JP	BEEP
MEM1:	LD	C, 32		; ano, nizky ton
	JP	BEEP	
RAM2:	LD	HL, 4000h
	LD	IY, RAM3	; pockaj trochu medzi bitmi
	JP	WAIT
RAM3:	DJNZ	RAM1
	LD	HL, 0000	; cakaj pred druhym testom
	LD	IY, MEM2
	JP	WAIT
MEM2:	LD	HL, 5555h
	LD	(HL), 00h
	LD	E, (HL)
	LD	B, 8
	LD	IX, RAM5
RAM4:	LD	A, E
	RRCA
	LD	E,A
	JR	C, MEM3		; zhoduje sa bit?
	LD	C, 32		; ano, nizky ton
	JP	BEEP
MEM3:	LD	C, 128		; nie, vysoky ton
	JP	BEEP	
RAM5:	LD	HL, 4000h
	LD	IY, RAM6	; pockaj trochu 
	JP	WAIT
RAM6:	DJNZ	RAM4
; --------------------------------------------	
; dump RAM cez seriovu linku
; dump 00
RAMDUMP:LD	HL, 5000h	; niekde vo vyssej RAM
	LD	(HL), 0		; zaplnit nulami
	LD	DE, 5001h
	LD	BC, 4000h	
	LDIR
	LD	HL, 5000h	; zaciatok pamate
	LD	BC, 4000h	; velkost RAM dumpu
	LD	IX, RAMDMP1	; navratova adresa zo seriovej rutiny
RAMDMP0:LD	A, (HL)		; nacitaj z ROM
	EXX			; vymena registrov
	JP	T57k6		; odosli cez seriovy port
RAMDMP1:EXX
	INC	HL
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, RAMDMP0	; nacitaj dalsi bajt
; --------------------------------------------	
; dump FF
	LD	HL, 5000h	; niekde vo vyssej RAM
	LD	(HL), 0FFh	; zaplnit jednotkami
	LD	DE, 5001h
	LD	BC, 4000h	
	LDIR
	LD	HL, 5000h	; zaciatok pamate
	LD	BC, 4000h	; velkost RAM dumpu
	LD	IX, RAMDMP3	; navratova adresa zo seriovej rutiny
RAMDMP2:LD	A, (HL)		; nacitaj z ROM
	EXX			; vymena registrov
	JP	T57k6		; odosli cez seriovy port
RAMDMP3:EXX
	INC	HL
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, RAMDMP2	; nacitaj dalsi bajt
; --------------------------------------------		
; koniec testu pamate, zapipaj
	LD	IX, BEEP4
	LD	C, 32		; zapipaj stupnicu
	JP	BEEP
BEEP4:	LD	IX, BEEP5
	LD	C, 64
	JP	BEEP
BEEP5:	LD	IX, BEEP6
	LD	C, 128
	JP	BEEP
BEEP6:  LD	C, 192
; --------------------------------------------	
; test klavesy, caka na podrzanie medzery
ENDLOOP:LD	IX, ELOOP1
	JP	BEEP
ELOOP1:	LD	HL, 0
	LD	IY, ELOOP2
	JP	WAIT
ELOOP2:	LD	A, I		; mapuj in-port a prislusnu pamat
	OR	100b
	OUT	(LS174)	, A
	LD	HL, 0FF03h	; adresa portu, aktivny Y3 na klavesnici (medzera)
	LD	A, (HL)		; nacitaj port
	OR	10100000b	; dopln BUSY a MGF-IN
	INC	A		; su vsetky linky hore?
	JR	NZ, GOROM	; medzera bola stlacena alebo prislo nieco cez seriovy port	
	JR	ENDLOOP
GOROM:	LD	A, 000b		; mapuj ALLRAM
	OUT	(LS174)	, A
	JP	0000		; navrat do Cold Mountains		
; --------------------------------------------
BEEP:   LD	A, C		; ton do A
	OR	11111b		; ostatne linky zostanu hore
	OUT	(LS175), A
	LD	HL, 16384	; 0,25s
	LD	IY, NOBEEP	; navratova adresa
	JP	WAIT		; cakaj
NOBEEP:	LD	A, 11111b	; vypni zvuk
	OUT	(LS175), A
	JP	(IX)		; navrat
; --------------------------------------------	
WAIT:	DEC	HL		; 11T cakacia slucka
	LD	A, H		; 4T
	OR	L		; 4T
	JR	NZ, WAIT	; 12T, spolu 31T (15,5us) * 65536 = 1s
	JP	(IY)		; navrat
; --------------------------------------------
; --------------------------------------------
; odvysielanie bajtu z reg. A na seriovu linku
; rychlostou 57600 Bd, sirka bitu je 35T (odchylka 1%)
; vyuziva registre HL, BC, A
; --------------------------------------------
T57k6:	RLCA                    ; prvy posun o jeden bit (vysiela sa cez 2. bit)
	LD	L, A		; uschovaj byte
	LD      H, 00000100b    ; v H bude maska pre skratenie instrukcie AND zo 7T na 4T
	LD	C, 00011000b	; dtto v C
        LD	A, C		; ponechaj STB, rele vypni, zapni LED
	OUT	(LS175), A	; zapni start-bit (log. 0)
				; priprav 0. bit
	RLC	L		;  8T	este jeden posun na 2. bit
	LD	A, L		;  4T    pouzi uschovany bajt
	AND	H       	;  4T    len 2.bit
	OR	C		;  4T    a este STB
	NOP			;  4T	 pockaj
	OUT	(LS175), A	; 11T    odvysielaj
				; spolu 35T, bude sa opakovat este 7-krat
	RRC	L		;  8T    prichystaj dalsi bit
        LD	A, L		;  4T    1
	AND	H       	;  4T
	OR	C		;  4T
	NOP
	OUT	(LS175), A	; 11T
	RRC	L		;  8T
        LD	A, L		;  4T    2
	AND	H       	;  4T
	OR	C		;  4T
	NOP
	OUT	(LS175), A	; 11T
	RRC	L		;  8T
	LD	A, L		;  4T    3
	AND	H       	;  4T
	OR	C		;  4T
	NOP
	OUT	(LS175), A	; 11T
	RRC	L		;  8T
        LD	A, L		;  4T    4
	AND	H       	;  4T
	OR	C		;  4T
	NOP
	OUT	(LS175), A	; 11T
	RRC	L		;  8T
        LD	A, L		;  4T    5
	AND	H       	;  4T
	OR	C		;  4T
	NOP
	OUT	(LS175), A	; 11T
	RRC	L		;  8T
        LD	A, L		;  4T    6
	AND	H       	;  4T
	OR	C		;  4T
	NOP
	OUT	(LS175), A	; 11T
	RRC	L		;  8T
        LD	A, L		;  4T    7
	AND	H       	;  4T
	OR	C		;  4T
	NOP
	OUT	(LS175), A	; 11T
	LD	A, C		;  4T	00011000	
	RRCA			;  4T	00001100
	RRCA			;  4T	00000110
	OR	C		;  4T	00011110
	RRCA			;  4T	00001111
	OR	C		;  4T	00011111
	OUT	(LS175), A	; 11T	 zapni stop-bit, vypni LED
        JP 	(IX)            ; sirka stop-bitu vznikne automaticky
	                        ; z casov dalsich instrukcii
; --------------------------------------------
; druha hlavicka - definovanie startovacej adresy 
lnchr:	DB	02h	
	DW	pstart
; --------------------------------------------
; vypocet adries

fstart  EQU 	pstart - 5
length  EQU 	lnchr - pstart
	END